#! /usr/local/bin/python

#
# Create and initialize table
#
# Author: Oleg BroytMann, phd2@earthling.net
# Copyright (C) 1998 PhiloSoft Design
#
# License: GPL
#

import sys, string

# Open X11 rgb file
try:
   infile = open("/usr/openwin/lib/X11/rgb.txt")
except IOError:
   print "Cannot open rgb.txt, aborted"
   sys.exit(1)

# Connect to databse
from rgb_connect import rgb_connect
db = rgb_connect()

# Create tables
db.query("""CREATE TABLE rgb (
   c_name   varchar(80) not null,   -- Color's name, e.g. LightGreen
   r        int2,                   -- r, g, b
   g        int2,
   b        int2,
   check (
      r >= 0 and r <= 255 and
      g >= 0 and g <= 255 and
      b >= 0 and b <= 255
   ));

   GRANT select ON rgb TO PUBLIC
""")

def define_color(name, r, g, b):
   db.query("""INSERT INTO rgb
      VALUES ('%s', %d, %d, %d)
   """ % (name, r, g, b))

# Fill rows: add colors
try:
   while 1:
      line = infile.readline()
      if not line:
         break

      l = string.split(line)

      if len(l) < 4: # Wrong format, skip
         continue

      if l[0][0] == '!': # Comment, skip
         continue

      try:
         r, g, b = map(string.atoi, l[0:3])
      except string.atoi_error: # Wrong format, skip
         continue

      name = string.join(l[3:])
      define_color(name, r, g, b)

except IOError:
   pass

infile.close()
