#! /usr/local/bin/python

#
# Show HTML table full of colors
#
# Author: Oleg BroytMann, phd2@earthling.net
# Copyright (C) 1998 PhiloSoft Design
#
# License: GPL
#


import sys, os, string


def start_html():
   print "Content-Type: text/html"
   print

   print """<HTML>

<TITLE>
   Color cube - PyGres CGI example
</TITLE>

<BODY>
"""

def finish_html():
   print """
</BODY>

</HTML>"""

def rgb_str(s):
   h = hex(s)[2:4]
   if len(h) == 1:
      h = '0' + h
   return h
   

def error():
   print "Status: 400"
   start_html()
   print "Bad request. You must give paramtere 'cube'. cube must be integer between 1 and 8."
   finish_html()
   sys.exit(1)


import cgi
params = cgi.FieldStorage()


try:
   cube = params["cube"].value
except KeyError:
   error()

try:
   cube = string.atoi(cube)
except string.atoi_error:
   error()

if not (1 <= cube <= 8):
   error()

colorcube = (
   (0, 0, 0),
   (0, 0, 128),
   (0, 128, 0),
   (0, 128, 128),
   (128, 0, 0),
   (128, 0, 128),
   (128, 128, 0),
   (128, 128, 128)
)

r, g, b = colorcube[cube-1]


# Connect to databse
from rgb_connect import rgb_connect
db = rgb_connect()

# Run query
query = db.query("""SELECT * FROM rgb
   WHERE r BETWEEN %d AND %d AND
         g BETWEEN %d AND %d AND
         b BETWEEN %d AND %d
   ORDER BY r, g, b
""" % (r, r+127, g, g+127, b, b+127))

start_html()
print """<TABLE ALIGN=center border=2>
<CAPTION>Color Table</CAPTION>
   <TR>
      <TH>Color</TH> <TH>R</TH> <TH>G</TH> <TH>B</TH> <TH>sample</TH>
   </TR>"""
for line in query.getresult():
   print "   <TR>"
   r, g, b = line[1:]
   print "      <TD>%s</TD> <TD>%d</TD> <TD>%d</TD> <TD>%d</TD> <TD bgcolor=\"#%s\">sample</TD>" % (line[0], r, g, b, rgb_str(r) + rgb_str(g) + rgb_str(b))
   print "   </TR>"
print "</TABLE>"

try:
   script_name = os.environ["SCRIPT_NAME"]
except KeyError:
   finish_html()
   sys.exit(0)

_s = ""
if cube > 1:
   _s = _s + "<A HREF=\"%s?cube=%d\">Prev</A>" % (script_name, cube-1)
if 1 < cube < 8:
   _s = _s + "&nbsp;"
if cube < 8:
   _s = _s + "<A HREF=\"%s?cube=%d\">Next</A>" % (script_name, cube+1)
print _s

finish_html()
